[![NPM version][npm-version-image]][npm-url] [![NPM downloads][npm-downloads-image]][npm-url] [![MIT License][license-image]][license-url] [![Build Status][travis-image]][travis-url] [![Gitter chat](https://badges.gitter.im/totaljs/framework.png)](https://gitter.im/totaljs/framework)

![total.js logo](https://www.totaljs.com/download/logo-black.png)

web framework for node.js
=========================

__total.js__ is the web application framework for creating rich web sites and web services. The framework doesn't have any dependencies and it has very good documentation + contains many examples. Please support the framework on GitHub and on other social networks.

```
$ npm install total.js
```

- [__Download__ empty-project with the framework](https://github.com/totaljs/framework/releases)
- [Homepage](http://www.totaljs.com)
- [Features](http://www.totaljs.com/features/)
- [__Documentation__](http://docs.totaljs.com)
- [Gitter - Chat for GitHub](https://gitter.im/totaljs/framework)
- [Discussion forum](https://groups.google.com/forum/#!forum/totaljs)
- [Changelog](https://github.com/totaljs/framework/blob/master/changes.txt)
- [__Download__ Modules & Packages](https://github.com/totaljs/modules) (View Engines, Session, Auth, etc.)
- [__Download__ Examples](https://github.com/totaljs/examples)

__Interesting__:

- Framework supports [NoSQL Embedded database](https://github.com/petersirka/nosql) for max. 20 000 documents per database

__Social networks__:

- [__Discussion forum__](https://groups.google.com/forum/#!forum/totaljs)
- [Follow total.js on GitHub](https://github.com/totaljs/framework)
- [Follow total.js on Twitter - __@totalframework__](https://twitter.com/totalframework)
- [Follow total.js on Facebook](https://www.facebook.com/totaljs.web.framework)
- [Follow total.js on Google Plus](https://plus.google.com/u/0/113175077493180148081/posts)
- [Follow total.js on LinkedIn](https://www.linkedin.com/groups/totaljs-8109884)

References
----------

- [Warstore.sk (Ecommerce)](https://www.warstore.sk)
- [Spektrum-bb.sk (Ecommerce)](https://www.spektrum-bb.sk)
- [Privater (WebSocket) - www.privater.eu](https://www.privater.eu)
- [GPS Localization (WebSocket) - www.gpslocalization.com](http://www.gpslocalization.com)
- [Online Clipboard (CouchDB) - www.online-clipboard.com](https://www.online-clipboard.com)

... and many more.

__Client-side libraries__

- [jQuery jComponent](https://github.com/petersirka/jComponent)
- [jQuery two way bindings](https://github.com/petersirka/jquery.bindings)
- [Tangular - template engine like Angular.js](https://github.com/petersirka/Tangular)
- [jQuery file upload (+ drag&drop)](https://github.com/petersirka/jquery.upload)

***

Videos on YouTube
-----------------

- VIDEO: [Why is node.js awesome? WebSocket + nginx + total.js + HTML + JavaScript ](http://www.youtube.com/watch?v=4Vrqx0UnpYk)
- VIDEO: [Node.js / total.js debugging of web applications](http://www.youtube.com/watch?v=4wLq_bJ_sfs)
- VIDEO: [total.js / node.js - balancing of requests](http://www.youtube.com/watch?v=1VOJ7cWoboo)
- VIDEO: [HTML 5 Server-Sent Events (JavaScript) via total.js & node.js](http://www.youtube.com/watch?v=XoWIv3xGxR4)
- VIDEO: [node.js / total.js - Live streaming via multipart/x-mixed-replace + CSS auto vendor prefix](http://www.youtube.com/watch?v=qZqO4c4Fw2k)
- VIDEO: [Deployment of total.js / node.js website on appfog.com (freehosting)](http://www.youtube.com/watch?v=kZvCCyR6iBI)
- VIDEO: [WebSocket (Real-time) HTML5 Chat in 5 minutes - node.js & total.js](http://www.youtube.com/watch?v=lW1vsKMUaKg)
- VIDEO: [total.js / web application framework for node.js](http://www.youtube.com/watch?v=3GMQJki82Lo)

## Contributors

- Peter Širka, <https://github.com/petersirka>
- Toshiaki Takahashi, <https://github.com/toshipon>
- Bir, <https://github.com/bir>
- Serkan Kocaman, <https://github.com/KiPSOFT>
- Andrea Sessa, <https://github.com/asessa>
- Ehsan Darrudi, <https://github.com/darrudi>
- Tom Spaccialbelli, <https://github.com/harry-stot>

## Contact

Peter Širka - <petersirka@gmail.com>

[license-image]: http://img.shields.io/badge/license-MIT-blue.svg?style=flat
[license-url]: license.txt

[npm-url]: https://npmjs.org/package/total.js
[npm-version-image]: http://img.shields.io/npm/v/total.js.svg?style=flat
[npm-downloads-image]: http://img.shields.io/npm/dm/total.js.svg?style=flat

[travis-url]: http://travis-ci.org/totaljs/framework
[travis-image]: http://img.shields.io/travis/totaljs/framework.svg?style=flat
